package com.example.todo.client;

import java.util.List;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.dom.client.Style.Unit;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.user.client.Command;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.DockLayoutPanel;
import com.google.gwt.user.client.ui.ListBox;
import com.google.gwt.user.client.ui.MenuBar;
import com.google.gwt.user.client.ui.MenuItem;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.TextArea;

/**
 * Entry point classes define <code>onModuleLoad()</code>.
 */
public class TodoViewer implements EntryPoint {
	private List<Todo> todos;

	public void onModuleLoad() {
		RootPanel rootPanel = RootPanel.get();
		
		DockLayoutPanel dockLayoutPanel = new DockLayoutPanel(Unit.EM);
		rootPanel.add(dockLayoutPanel, 0, 0);
		dockLayoutPanel.setSize("100%", "100%");
		
		MenuBar menuBar = new MenuBar(false);
		dockLayoutPanel.addNorth(menuBar, 1.9);
		menuBar.setSize("100%", "20");
		MenuBar menuBar_1 = new MenuBar(true);
		
		MenuItem mntmFile = new MenuItem("File", false, menuBar_1);
		
		MenuItem mntmFoo = new MenuItem("Foo", false, (Command) null);
		menuBar_1.addItem(mntmFoo);
		menuBar.addItem(mntmFile);
		
		final ListBox listBox = new ListBox();
		dockLayoutPanel.addWest(listBox, 7.7);
		listBox.setHeight("100%");
		listBox.setVisibleItemCount(5);
		
		TodoService.Util.getInstance().getTodos(new AsyncCallback<List<Todo>>(){

			@Override
			public void onFailure(Throwable caught) {
				Window.alert(caught.getLocalizedMessage());
			}

			@Override
			public void onSuccess(List<Todo> result) {
				todos = result;
					for (Todo todo:result) {
						listBox.addItem(todo.getTitle());
					}
			}
			
		});
		final TextArea txtrItemview = new TextArea();
		listBox.addClickHandler(new ClickHandler(){

			@Override
			public void onClick(ClickEvent event) {
				Todo selectedTodo = todos.get(listBox.getSelectedIndex());
				txtrItemview.setTitle(selectedTodo.getTitle());
				String content = "";
				for (String item: selectedTodo.getItems())
					content += "\n"+item;
				txtrItemview.setText(content);				
			}
			
		});
		
		
		txtrItemview.setText("itemView");
		dockLayoutPanel.add(txtrItemview);
		txtrItemview.setSize("100%", "100%");
	}
}
